package com.iformall.controller.basic;

import com.iformall.annotation.SystemControllerLog;
import com.iformall.controller.base.BaseController;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import com.github.pagehelper.PageInfo;
import com.iformall.common.Result;
import com.iformall.common.ResultData;

import com.iformall.domain.po.WxMallFloor;
import com.iformall.service.WxMallFloorService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;

@RestController
@RequestMapping("wxMallFloor")
public class WxMallFloorController extends BaseController {
    private final Logger logger = LoggerFactory.getLogger(this.getClass());

    @Autowired
    private WxMallFloorService wxMallFloorService;

    @ApiOperation("分页列表接口")
    @GetMapping("list")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "页数", dataType = "int", paramType = "query", required = true),
            @ApiImplicitParam(name = "pageSize", value = "每页条数", dataType = "int", paramType = "query", required = true)})
    @SystemControllerLog(description = "商城-楼层-列表")
    public ResultData list(@ModelAttribute WxMallFloor wxMallFloor, Integer pageNum, Integer pageSize) {
        logger.debug("[" + getIpAddr() + "] WxMallFloorController::list");
        if (null == wxMallFloor) wxMallFloor = new WxMallFloor();
        final PageInfo<WxMallFloor> page = wxMallFloorService.listAsPage(wxMallFloor, pageNum, pageSize);
        return new ResultData(page);
    }

    @ApiOperation("新增接口(4)")
    @PostMapping("add")
    @SystemControllerLog(description = "商城-楼层-新增")
    public ResultData add(@RequestBody WxMallFloor wxMallFloor) {
        logger.debug("[" + getIpAddr() + "] WxMallFloorController::add");
        //Assert.notNull(wxMallFloor.getName(), "角色名不能为空");
        //Assert.isTrue(!checkUnique(sysRole.getName(), null), "重复的角色名");
        wxMallFloorService.saveOrUpdate(wxMallFloor);
        return new ResultData();
    }

    @ApiOperation("根据id更新接口")
    @PostMapping("update")
    @SystemControllerLog(description = "商城-楼层-更新")
    public ResultData update(@RequestBody WxMallFloor wxMallFloor) {
        logger.debug("[" + getIpAddr() + "] WxMallFloorController::update");
        wxMallFloorService.saveOrUpdate(wxMallFloor);
        return new ResultData();
    }

    @ApiOperation("根据id删除接口")
    @GetMapping("/del")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    @SystemControllerLog(description = "商城-楼层-删除")
    public ResultData delete(Long id) {
        logger.debug("[" + getIpAddr() + "] WxMallFloorController::delete");
        wxMallFloorService.deleteById(id);
        return new ResultData(Result.SUCCESS, "删除成功", null);
    }

    @ApiOperation("根据id查询接口")
    @GetMapping("/findById")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    @SystemControllerLog(description = "商城-楼层-查询")
    public ResultData findById(Long id) {
        logger.debug("[" + getIpAddr() + "] WxMallFloorController::findById");
        return new ResultData(Result.SUCCESS, "查询成功", wxMallFloorService.getById(id));
    }

    @ApiOperation("获取所有数据")
    @GetMapping("getfloorlist")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "buildingId", value = "楼座ID", dataType = "Long", paramType = "query", required = true)})
    @SystemControllerLog(description = "商城-楼座-楼层")
    public ResultData getfloorlist(Long buildingId) {
        logger.debug("[" + getIpAddr() + "] WxMallFloorController::getfloorlist");
        return wxMallFloorService.getfloorlist(getTenantId(), buildingId);
    }


}
